aboutsummaryrefslogtreecommitdiffstats
path: root/tools/testing/selftests/net/forwarding/sch_tbf_root.sh
diff options
context:
space:
mode:
authorPetr Machata <petrm@mellanox.com>2020-01-24 15:23:18 +0200
committerDavid S. Miller <davem@davemloft.net>2020-01-25 10:56:31 +0100
commite814c58d454d952778fbb70bd0e71564f8c49f28 (patch)
treea231c9157bdc69e48e58a4c8b3d05dff94edc14c /tools/testing/selftests/net/forwarding/sch_tbf_root.sh
parentselftests: forwarding: lib: Allow reading TC rule byte counters (diff)
downloadlinux-dev-e814c58d454d952778fbb70bd0e71564f8c49f28.tar.xz
linux-dev-e814c58d454d952778fbb70bd0e71564f8c49f28.zip
selftests: mlxsw: Add a TBF selftest
Add a test that runs traffic across a port throttled with TBF. The test checks that the observed throughput is within +-5% from the installed shaper. To allow checking both the software datapath and the offloaded one, make the test suitable for inclusion from driver-specific wrapper. Introduce such wrappers for mlxsw. Signed-off-by: Petr Machata <petrm@mellanox.com> Signed-off-by: Ido Schimmel <idosch@mellanox.com> Signed-off-by: David S. Miller <davem@davemloft.net>
Diffstat (limited to '')
-rwxr-xr-xtools/testing/selftests/net/forwarding/sch_tbf_root.sh33
1 files changed, 33 insertions, 0 deletions
diff --git a/tools/testing/selftests/net/forwarding/sch_tbf_root.sh b/tools/testing/selftests/net/forwarding/sch_tbf_root.sh
new file mode 100755
index 000000000000..72aa21ba88c7
--- /dev/null
+++ b/tools/testing/selftests/net/forwarding/sch_tbf_root.sh
@@ -0,0 +1,33 @@
+#!/bin/bash
+# SPDX-License-Identifier: GPL-2.0
+
+ALL_TESTS="
+ ping_ipv4
+ tbf_test
+"
+: ${lib_dir:=.}
+source $lib_dir/sch_tbf_core.sh
+
+tbf_test_one()
+{
+ local bs=$1; shift
+
+ tc qdisc replace dev $swp2 root handle 108: tbf \
+ rate 400Mbit burst $bs limit 1M
+ do_tbf_test 10 400 $bs
+}
+
+tbf_test()
+{
+ tbf_test_one 128K
+ tc qdisc del dev $swp2 root
+}
+
+trap cleanup EXIT
+
+setup_prepare
+setup_wait
+
+tests_run
+
+exit $EXIT_STATUS